IF OBJECT_ID ( 'VW_CSC_SERVER', 'V' ) IS NOT NULL 
   DROP VIEW VW_CSC_SERVER;
go
CREATE VIEW [dbo].[VW_CSC_SERVER]
AS
SELECT S.SERVER_NAME, S.THREAD_PROCESS, SUM(CASE WHEN PROCESS_TYPE <> 'W' AND PROCESS_GROUP = 'P' AND PROCESS_TYPE <> 'R' THEN 1 ELSE 0 END) 
  AS PROCESS_NORMAL, S.THREAD_WORKFLOW, SUM(CASE WHEN PROCESS_TYPE = 'W' AND PROCESS_GROUP = 'P' THEN 1 ELSE 0 END) 
  AS PROCESS_WORKFLOW, S.THREAD_REPORT, SUM(CASE WHEN charindex(PROCESS_GROUP, 'RIEM') > 0 THEN 1 ELSE 0 END) AS PROCESS_REPORT, 
  S.LAST_ACTION, S.LAST_ASSIGN, S.SERVER_STATUS, S.START_DATETIME , S.SERVER_PRODUCTION
FROM dbo.CSC_SERVER AS S WITH(NOLOCK) LEFT OUTER JOIN
  dbo.CSC_QUQUE AS Q WITH (NOLOCK) ON S.SERVER_NAME = Q.SERVER_NAME AND (Q.PROCESS_STATUS = 'R' OR
  (S.SERVER_PRODUCTION = '1' AND Q.PROCESS_STATUS = 'T'))
where S.SERVER_STATUS = '1'
GROUP BY S.SERVER_NAME, S.THREAD_PROCESS, S.THREAD_WORKFLOW, S.THREAD_REPORT, S.LAST_ACTION, S.LAST_ASSIGN, S.SERVER_STATUS, S.START_DATETIME , S.SERVER_PRODUCTION

GO
