IF OBJECT_ID ( 'getReadyServer', 'FN' ) IS NOT NULL 
   DROP function getReadyServer;
go
/*
	@group = P = process
		@type = W = workflow
		@type = R = auto
		@type = N = normall
	@group = RIEM = report,import,export
*/
create function getReadyServer(@group varchar(1) , @type varchar(1))
returns varchar(max)
as
begin
	declare @server varchar(max)
	set @server = ''
	if @group = 'P' 
	begin
		if @type = 'W'
		begin
			select top 1 @server = server_name from vw_csc_server 
			where thread_workflow > process_workflow and server_production = '1'
			order by process_workflow,last_assign
		end
		else
		begin
			select top 1 @server = server_name from vw_csc_server 
			where thread_process > process_normal and server_production = '1'
			order by process_normal,last_assign
		end
	end
	else
	begin
		select top 1 @server = server_name from vw_csc_server 
		where thread_report > process_report and server_production = '1'
		order by process_report,last_assign
	end
	return @server
end