IF OBJECT_ID ( 'time_in_zone', 'FN' ) IS NOT NULL 
   DROP function time_in_zone;
go
/* return 1 = true , 0 = false */
CREATE FUNCTION time_in_zone(@mytime datetime ,@beg_zone datetime , @end_zone datetime)
RETURNS int
AS
BEGIN
  IF @beg_zone <= @mytime and @mytime <= @end_zone
  BEGIN
    return 1;
  END
  return 0;
END
go
IF OBJECT_ID ( 'getDiffIntersecTimeZone', 'FN' ) IS NOT NULL 
   DROP function getDiffIntersecTimeZone;
go
CREATE FUNCTION getDiffIntersecTimeZone(@in_beg_zone datetime , @out_beg_zone datetime , @in_end_zone datetime , @out_end_zone datetime)
returns varchar(7)
as
begin
  declare @bgin int = 0;
  declare @enin int = 0;
  declare @bg datetime;
  declare @en datetime;
  declare @min int;
  declare @hh int;
  declare @mm int;
  SET @bgin = dbo.time_in_zone(@in_end_zone , @in_beg_zone , @out_beg_zone);
  SET @enin = dbo.time_in_zone(@out_end_zone , @in_beg_zone , @out_beg_zone);
  IF @bgin = 1 and @enin = 1
  BEGIN
    SET @bg = @in_end_zone;
    SET @en = @out_end_zone;
  END
  ELSE IF @bgin = 1
  BEGIN
    SET @bg = @in_end_zone;
    SET @en = @out_beg_zone;
  END
  ELSE IF @enin = 1
  BEGIN
    SET @bg = @in_beg_zone;
    SET @en = @out_end_zone;
  END
  ELSE
  BEGIN
    SET @bgin = dbo.time_in_zone(@in_beg_zone , @in_end_zone , @out_end_zone);
    SET @enin = dbo.time_in_zone(@out_beg_zone , @in_end_zone , @out_end_zone);
    IF @bgin = 1 and @enin = 1
    BEGIN
      SET @bg = @in_beg_zone;
      SET @en = @out_beg_zone;
    END
    ELSE IF @bgin = 1
    BEGIN
      SET @bg = @in_beg_zone;
      SET @en = @out_end_zone;
    END
    ELSE IF @enin = 1
    BEGIN
      SET @bg = @in_end_zone;
      SET @en = @out_beg_zone;
    END
    ELSE
    BEGIN
      return '0.00';
    END
  END
  SET @min = DATEDIFF(minute, @bg , @en);
  SET @hh = @min / 60;
  SET @mm = @min % 60;
  IF @mm < 10
  BEGIN
    return cast(@hh as varchar(4))+'.0'+cast(@mm as varchar(2));
  END
  return cast(@hh as varchar(4))+'.'+cast(@mm as varchar(2));
end

